### Method

# Gio Socket accept

since: 2.22

#### Declaration

    GSocket*
    g_socket_accept (
      GSocket* socket,
      GCancellable* cancellable,
      GError** error
    )

#### Description

Accept incoming connections on a connection-based socket. This removes the first outstanding connection request from the listening socket and creates a `GSocket` object for it.

The `socket` must be bound to a local address with `g_socket_bind()` and must be listening for incoming connections (g_socket_listen()).

If there are no outstanding connections then the operation will block or return `G_IO_ERROR_WOULD_BLOCK` if non-blocking I/O is enabled. To be notified of an incoming connection, wait for the `G_IO_IN` condition.

Available since: 2.22

#### Parameters

`cancellable`

  Type: `GCancellable`

  A %GCancellable or `NULL`.

  The argument can be `NULL`.
  The data is owned by the caller of the method.

`error`

  Type: `GError **`

  The return location for a recoverable error.

  The argument can be `NULL`.
  If the return location is not `NULL`, then you must initialize it to a `NULL` `GError*`.
  The argument will be left initialized to `NULL` by the method if there are no errors.
  In case of error, the argument will be set to a newly allocated `GError`; the caller will take ownership of the data, and be responsible for freeing it.

#### Return value

Type: `GSocket`

A new `GSocket`, or `NULL` on error. Free the returned object with g_object_unref().

The caller of the method takes ownership of the data, and is responsible for freeing it.